Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 4226)
+++ /palm/trunk/SOURCE/Makefile	(revision 4227)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Add palm_date_time_mod, remove date_and_time_mod
+#
+# 4223 2019-09-10 09:20:47Z gronemeier
 # Corrected "Former revisions" section
 # 
@@ -138,5 +141,4 @@
 	data_output_spectra.f90 \
 	data_output_tseries.f90 \
-	date_and_time_mod.f90 \
 	diagnostic_output_quantities_mod.f90 \
 	diffusion_s.f90 \
@@ -187,4 +189,5 @@
 	outflow_turbulence.f90 \
 	palm.f90 \
+	palm_date_time_mod.f90 \
 	parin.f90 \
 	plant_canopy_model_mod.f90 \
@@ -324,8 +327,8 @@
 biometeorology_mod.o: \
 	basic_constants_and_equations_mod.o \
-	date_and_time_mod.o \
-	modules.o \
-	mod_kinds.o \
-	netcdf_data_input_mod.o \
+	modules.o \
+	mod_kinds.o \
+	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o
 boundary_conds.o: \
@@ -381,8 +384,8 @@
 	chem_gasphase_mod.o \
 	chem_modules.o \
-	date_and_time_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_data_input_mod.o \
+	mod_kinds.o \
+	modules.o \
+	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	surface_mod.o
 chemistry_model_mod.o: \
@@ -392,9 +395,9 @@
 	chem_modules.o \
 	chem_photolysis_mod.o \
-	date_and_time_mod.o \
 	diffusion_s.o \
 	mod_kinds.o \
 	modules.o \
 	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o \
 	surface_mod.o
@@ -411,4 +414,5 @@
 	mod_kinds.o \
 	modules.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o
 close_file.o: \
@@ -503,7 +507,4 @@
 	radiation_model_mod.o \
 	urban_surface_mod.o
-date_and_time_mod.o: \
-	mod_kinds.o \
-	modules.o
 diagnostic_output_quantities_mod.o: \
 	mod_kinds.o \
@@ -578,5 +579,4 @@
 	bulk_cloud_model_mod.o \
 	cpulog_mod.o \
-	date_and_time_mod.o \
 	model_1d_mod.o \
 	module_interface.o \
@@ -585,4 +585,5 @@
 	netcdf_interface_mod.o \
 	ocean_mod.o \
+	palm_date_time_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_handle_communicator_mod.o \
@@ -592,8 +593,8 @@
 indoor_model_mod.o: \
 	cpulog_mod.o \
-	date_and_time_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_data_input_mod.o \
+	mod_kinds.o \
+	modules.o \
+	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	surface_mod.o \
 	urban_surface_mod.o
@@ -621,4 +622,5 @@
 	random_generator_parallel_mod.o \
 	read_restart_data_mod.o \
+	palm_date_time_mod.o \
 	surface_layer_fluxes_mod.o \
 	surface_mod.o \
@@ -779,4 +781,5 @@
 	netcdf_data_input_mod.o \
 	ocean_mod.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o \
 	salsa_mod.o \
@@ -810,5 +813,4 @@
 	chem_photolysis_mod.o \
 	cpulog_mod.o \
-	date_and_time_mod.o \
 	diagnostic_output_quantities_mod.o \
 	land_surface_model_mod.o \
@@ -825,8 +827,10 @@
 	time_to_string.o \
 	write_restart_data_mod.o
+palm_date_time_mod.o: \
+	mod_kinds.o \
+	modules.o
 parin.o: \
 	chem_modules.o \
 	cpulog_mod.o \
-	date_and_time_mod.o \
 	model_1d_mod.o \
 	mod_kinds.o \
@@ -952,8 +956,8 @@
 	bulk_cloud_model_mod.o \
 	calc_mean_profile.o \
-	date_and_time_mod.o \
 	mod_particle_attributes.o \
 	modules.o \
 	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	plant_canopy_model_mod.o \
 	surface_mod.o
@@ -970,5 +974,4 @@
 	chem_modules.o \
 	cpulog_mod.o \
-	date_and_time_mod.o \
 	diagnostic_output_quantities_mod.o \
 	mod_kinds.o \
@@ -977,4 +980,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o\
@@ -998,4 +1002,5 @@
 	diffusion_s.o \
 	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	plant_canopy_model_mod.o \
 	surface_mod.o \
@@ -1086,4 +1091,5 @@
 	nesting_offl_mod.o \
 	ocean_mod.o \
+	palm_date_time_mod.o \
 	pmc_interface_mod.o \
 	prognostic_equations.o \
@@ -1105,8 +1111,8 @@
 	basic_constants_and_equations_mod.o \
 	cpulog_mod.o \
-	date_and_time_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
 	modules.o \
+	palm_date_time_mod.o \
 	pmc_interface_mod.o \
 	radiation_model_mod.o \
@@ -1152,8 +1158,8 @@
 urban_surface_mod.o: \
 	basic_constants_and_equations_mod.o \
-	date_and_time_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_data_input_mod.o \
+	mod_kinds.o \
+	modules.o \
+	netcdf_data_input_mod.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o \
 	surface_mod.o
@@ -1253,5 +1259,4 @@
 	mod_kinds.o
 write_restart_data_mod.o: \
-	date_and_time_mod.o \
 	mod_kinds.o \
 	model_1d_mod.o \
@@ -1259,4 +1264,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	palm_date_time_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o \
Index: /palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4227)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4223 2019-09-10 09:20:47Z gronemeier
 ! Corrected "Former revisions" section
 ! 
@@ -140,7 +143,4 @@
                surface_pressure
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  calc_date_and_time, day_of_year, time_utc
-
     USE grid_variables,                                                        &
         ONLY:  ddx, dx, ddy, dy
@@ -155,4 +155,7 @@
         ONLY:  netcdf_data_input_uvem, uvem_projarea_f, uvem_radiance_f,       &
                uvem_irradiance_f, uvem_integration_f, building_obstruction_f
+
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time
 !
 !-- Import radiation model to obtain input for mean radiant temperature
@@ -4226,36 +4229,34 @@
 !-- UVEM specific subroutines
 
-!---------------------------------------------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Module-specific routine for new module
-!---------------------------------------------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE uvem_solar_position
-    
-    USE date_and_time_mod,                                                                                            &
-       ONLY:  calc_date_and_time, day_of_year, time_utc 
-    
-    USE control_parameters,                                                                                           &
-       ONLY:  latitude, longitude   
+
+    USE control_parameters,                                                                        &
+       ONLY:  latitude, longitude, time_since_reference_point
 
     IMPLICIT NONE
-    
-   
-    REAL(wp) ::  alpha       = 0.0_wp   !< solar azimuth angle in radiant    
-    REAL(wp) ::  doy_r       = 0.0_wp   !< real format of day_of_year           
-    REAL(wp) ::  declination = 0.0_wp   !< declination
-    REAL(wp) ::  dtor        = 0.0_wp   !< factor to convert degree to radiant
-    REAL(wp) ::  js          = 0.0_wp   !< parameter for solar position calculation
-    REAL(wp) ::  lat         = 52.39_wp !< latitude
-    REAL(wp) ::  lon         = 9.7_wp   !< longitude        
-    REAL(wp) ::  thetar      = 0.0_wp   !< angle for solar zenith angle calculation
-    REAL(wp) ::  thetasr     = 0.0_wp   !< angle for solar azimuth angle calculation    
-    REAL(wp) ::  zgl         = 0.0_wp   !< calculated exposure by direct beam   
-    REAL(wp) ::  woz         = 0.0_wp   !< calculated exposure by diffuse radiation
-    REAL(wp) ::  wsp         = 0.0_wp   !< calculated exposure by direct beam   
-   
-
-    CALL calc_date_and_time
-    doy_r = real(day_of_year)   
+
+    INTEGER(iwp) ::  day_of_year = 0       !< day of year
+
+    REAL(wp) ::  alpha         = 0.0_wp    !< solar azimuth angle in radiant    
+    REAL(wp) ::  declination   = 0.0_wp    !< declination
+    REAL(wp) ::  dtor          = 0.0_wp    !< factor to convert degree to radiant
+    REAL(wp) ::  js            = 0.0_wp    !< parameter for solar position calculation
+    REAL(wp) ::  lat           = 52.39_wp  !< latitude
+    REAL(wp) ::  lon           = 9.7_wp    !< longitude
+    REAL(wp) ::  second_of_day = 0.0_wp    !< current second of the day
+    REAL(wp) ::  thetar        = 0.0_wp    !< angle for solar zenith angle calculation
+    REAL(wp) ::  thetasr       = 0.0_wp    !< angle for solar azimuth angle calculation    
+    REAL(wp) ::  zgl           = 0.0_wp    !< calculated exposure by direct beam   
+    REAL(wp) ::  woz           = 0.0_wp    !< calculated exposure by diffuse radiation
+    REAL(wp) ::  wsp           = 0.0_wp    !< calculated exposure by direct beam   
+
+
+    CALL get_date_time( time_since_reference_point, &
+                        day_of_year = day_of_year, second_of_day = second_of_day )
     dtor = pi / 180.0_wp
     lat = latitude
@@ -4263,5 +4264,5 @@
 !
 !-- calculation of js, necessary for calculation of equation of time (zgl) :
-    js=  72.0_wp * ( doy_r + ( time_utc / 86400.0_wp ) ) / 73.0_wp 
+    js=  72.0_wp * ( REAL( day_of_year, KIND=wp ) + ( second_of_day / 86400.0_wp ) ) / 73.0_wp 
 !
 !-- calculation of equation of time (zgl):
@@ -4270,5 +4271,5 @@
 !
 !-- calculation of apparent solar time woz:
-    woz = ( ( time_utc / 3600.0_wp ) - ( 4.0_wp * ( 15.0_wp - lon ) ) / 60.0_wp ) + ( zgl / 60.0_wp )
+    woz = ( ( second_of_day / 3600.0_wp ) - ( 4.0_wp * ( 15.0_wp - lon ) ) / 60.0_wp ) + ( zgl / 60.0_wp )
 !
 !-- calculation of hour angle (wsp):
Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4227)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4223 2019-09-10 09:20:47Z gronemeier
 ! Unused routine chem_emissions_check_parameters commented out due to uninitialized content
 ! 
@@ -118,10 +121,4 @@
         ONLY: chem_emis_att_type, chem_emis_val_type
 
-    USE date_and_time_mod,                                                   &
-        ONLY: day_of_month, hour_of_day,                                     &
-             index_mm, index_dd, index_hh,                                   &
-             month_of_year, hour_of_day,                                     &
-             time_default_indices, time_preprocessed_indices
-    
     USE chem_gasphase_mod,                                                   &
         ONLY: nvar, spc_names
@@ -905,5 +902,9 @@
 ! Description:
 ! ------------
-!> Routine for Update of Emission values at each timestep 
+!> Routine for Update of Emission values at each timestep.
+!>
+!> @todo Clarify the correct usage of index_dd, index_hh and index_mm. Consider
+!>       renaming of these variables.
+!> @todo Clarify time used in emis_lod=2 mode. ATM, the used time seems strange.
 !-------------------------------------------------------------------------------!
 
@@ -919,4 +920,9 @@
        ONLY: hyp, pt 
 
+    USE control_parameters, &
+        ONLY: time_since_reference_point
+
+    USE palm_date_time_mod, &
+        ONLY: days_per_week, get_date_time, hours_per_day, months_per_year, seconds_per_day
    
  IMPLICIT NONE
@@ -940,8 +946,19 @@
     INTEGER(iwp) ::  m                                                          !< running index for horizontal surfaces
 
+    INTEGER(iwp) ::  day_of_month                                               !< day of the month
+    INTEGER(iwp) ::  day_of_week                                                !< day of the week
+    INTEGER(iwp) ::  day_of_year                                                !< day of the year
+    INTEGER(iwp) ::  days_since_reference_point                                 !< days since reference point
+    INTEGER(iwp) ::  hour_of_day                                                !< hour of the day
+    INTEGER(iwp) ::  month_of_year                                              !< month of the year
+    INTEGER(iwp) ::  index_dd                                                   !< index day
+    INTEGER(iwp) ::  index_hh                                                   !< index hour
+    INTEGER(iwp) ::  index_mm                                                   !< index month
+
+    REAL(wp) ::  time_utc_init                                                  !< second of day of initial date
+
     !
     !-- CONVERSION FACTORS: TIME  
     REAL(wp), PARAMETER ::  hour_per_year =  8760.0_wp  !< number of hours in a year of 365 days  
-    REAL(wp), PARAMETER ::  hour_per_day  =    24.0_wp  !< number of hours in a day
     REAL(wp), PARAMETER ::  s_per_hour    =  3600.0_wp  !< number of sec per hour (s)/(hour)    
     REAL(wp), PARAMETER ::  s_per_day     = 86400.0_wp  !< number of sec per day (s)/(day)  
@@ -1073,6 +1090,11 @@
 !-- Update time indices
 
-          CALL time_preprocessed_indices( index_hh )
-
+          CALL get_date_time( 0.0_wp, second_of_day=time_utc_init )
+          CALL get_date_time( time_since_reference_point, hour=hour_of_day )
+
+          days_since_reference_point = INT( FLOOR( ( time_utc_init + time_since_reference_point ) &
+                                                   / seconds_per_day ) )
+
+          index_hh = days_since_reference_point * hours_per_day + hour_of_day
 
 !
@@ -1102,5 +1124,7 @@
 !-- Update time indices
 
-             CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
+             CALL get_date_time( time_since_reference_point, &
+                                 day_of_year=day_of_year, hour=hour_of_day )
+             index_hh = ( day_of_year - 1_iwp ) * hour_of_day
 
 !
@@ -1132,7 +1156,23 @@
 !
 !-- Update time indices
-             CALL time_default_indices( daytype_mdh, month_of_year, day_of_month,  &
-                  hour_of_day, index_mm, index_dd,index_hh )
-
+             CALL get_date_time( time_since_reference_point, &
+                                 month=month_of_year,        &
+                                 day=day_of_month,           &
+                                 hour=hour_of_day,           &
+                                 day_of_week=day_of_week     )
+             index_mm = month_of_year
+             index_dd = months_per_year + day_of_week
+             SELECT CASE(TRIM(daytype_mdh))
+
+                CASE ("workday")
+                   index_hh = months_per_year + days_per_week + hour_of_day
+
+                CASE ("weekend")
+                   index_hh = months_per_year + days_per_week + hours_per_day + hour_of_day
+
+                CASE ("holiday")
+                   index_hh = months_per_year + days_per_week + 2*hours_per_day + hour_of_day
+
+             END SELECT
 !
 !-- Check if the index is less or equal to the temporal dimension of MDH emission files
@@ -1189,5 +1229,6 @@
 
 !
-!-- Get time-factor for specific hour
+!--       Get time-factor for specific hour
+          CALL get_date_time( time_since_reference_point, hour=hour_of_day )
 
           index_hh = hour_of_day
@@ -1196,5 +1237,5 @@
        ENDIF  ! emiss_lod
 
-       
+
 !
 !--  Emission distribution calculation
@@ -1257,5 +1298,5 @@
                                                  time_factor(icat) *           &
                                                  emt_att%nox_comp(icat,1) *    &
-                                                 conversion_factor * hour_per_day
+                                                 conversion_factor * hours_per_day
 
                    emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
@@ -1270,5 +1311,5 @@
                                                  time_factor(icat) *           &
                                                  emt_att%nox_comp(icat,2) *    &
-                                                 conversion_factor * hour_per_day
+                                                 conversion_factor * hours_per_day
 
                    emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
@@ -1283,5 +1324,5 @@
                                                  time_factor(icat) *           &
                                                  emt_att%sox_comp(icat,1) *    &
-                                                 conversion_factor * hour_per_day
+                                                 conversion_factor * hours_per_day
 
                    emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
@@ -1298,5 +1339,5 @@
                                                  time_factor(icat) *           &
                                                  emt_att%sox_comp(icat,2) *    &
-                                                 conversion_factor * hour_per_day
+                                                 conversion_factor * hours_per_day
 
                    emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
@@ -1315,5 +1356,5 @@
                                                     time_factor(icat) *                  &
                                                     emt_att%pm_comp(icat,i_pm_comp,1) *  &
-                                                    conversion_factor * hour_per_day 
+                                                    conversion_factor * hours_per_day 
 
                       emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                       &
@@ -1333,5 +1374,5 @@
                                                     time_factor(icat) *                  &
                                                     emt_att%pm_comp(icat,i_pm_comp,2) *  &
-                                                    conversion_factor * hour_per_day 
+                                                    conversion_factor * hours_per_day 
 
                       emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                       &
@@ -1351,5 +1392,5 @@
                                                     time_factor(icat)     *              &
                                                     emt_att%pm_comp(icat,i_pm_comp,3) *  &
-                                                    conversion_factor * hour_per_day 
+                                                    conversion_factor * hours_per_day 
 
                       emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                       &
@@ -1372,5 +1413,5 @@
                                                        time_factor(icat) *               &
                                                        emt_att%voc_comp(icat,match_spec_voc_input(ivoc)) *   &
-                                                       conversion_factor * hour_per_day
+                                                       conversion_factor * hours_per_day
 
                          emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                    &
@@ -1389,5 +1430,5 @@
                    delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *                 &
                                                  time_factor(icat) *                     &
-                                                 conversion_factor * hour_per_day
+                                                 conversion_factor * hours_per_day
  
                    emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                          &
Index: /palm/trunk/SOURCE/chem_photolysis_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_photolysis_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/chem_photolysis_mod.f90	(revision 4227)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Change call to calc_zenith
+! 
+! 4223 2019-09-10 09:20:47Z gronemeier
 ! Corrected "Former revisions" section
 ! 
@@ -227,4 +230,7 @@
  SUBROUTINE photolysis_simple
 
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time
+
     USE radiation_model_mod,                                                   &
         ONLY:  calc_zenith, cos_zenith
@@ -232,6 +238,10 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) :: iphot,iav !< loop indix for photolysis reaction
-    REAL(wp)     :: coszi     !< 1./cosine of zenith angle
+    INTEGER(iwp) :: day_of_year  !< day of the year
+    INTEGER(iwp) :: iav          !< loop indix for photolysis reaction
+    INTEGER(iwp) :: iphot        !< loop indix for photolysis reaction
+
+    REAL(wp)     :: coszi          !< 1./cosine of zenith angle
+    REAL(wp)     :: second_of_day  !< second of the day
 
     DO  iphot = 1, nphot
@@ -239,5 +249,7 @@
     ENDDO
 
-    CALL calc_zenith
+    CALL get_date_time( time_since_reference_point, &
+                        day_of_year=day_of_year, second_of_day=second_of_day )
+    CALL calc_zenith( day_of_year, second_of_day )
 
     IF ( cos_zenith > 0.0_wp ) THEN
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4227)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -2996,11 +2999,12 @@
 
     USE control_parameters,                                                 &   
-         ONLY:  dt_3d, intermediate_timestep_count, latitude
+         ONLY:  dt_3d, intermediate_timestep_count, latitude,               &
+                time_since_reference_point
 
     USE arrays_3d,                                                          &
          ONLY:  dzw, rho_air_zw
 
-    USE date_and_time_mod,                                                  &
-         ONLY:  day_of_year
+    USE palm_date_time_mod,                                                 &
+         ONLY:  get_date_time
 
     USE surface_mod,                                                        &
@@ -3012,4 +3016,5 @@
 
 
+    INTEGER(iwp) ::  day_of_year                   !< current day of the year
     INTEGER(iwp), INTENT(IN) ::  i
     INTEGER(iwp), INTENT(IN) ::  j
@@ -3286,4 +3291,7 @@
          xm_O * 3 /)                                !< o3_biascorr
 !
+!-- Get current day of the year
+    CALL get_date_time( time_since_reference_point, day_of_year = day_of_year )
+!
 !-- Initialize surface element m
     m = 0
@@ -5849,3 +5857,2 @@
      
  END MODULE chemistry_model_mod
-
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 4226)
+++ /palm/trunk/SOURCE/header.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4223 2019-09-10 09:20:47Z gronemeier
 ! Write information about rotation angle
 ! 
@@ -75,7 +78,4 @@
         ONLY:  log_point_s
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  day_of_year_init, time_utc_init
-
     USE grid_variables,                                                        &
         ONLY:  dx, dy
@@ -100,4 +100,7 @@
                sa_vertical_gradient, sa_vertical_gradient_level,               &
                sa_vertical_gradient_level_ind
+
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time
 
     USE pegrid
@@ -137,4 +140,5 @@
     CHARACTER (LEN=70) ::  char1               !< dummy varialbe used for various strings
     CHARACTER (LEN=70) ::  char2               !< string containing informating about the advected distance in case of Galilei transformation
+    CHARACTER (LEN=23) ::  date_time_str       !< string for date and time information
     CHARACTER (LEN=70) ::  dopr_chr            !< string indicating profile output variables
     CHARACTER (LEN=70) ::  do2d_xy             !< string indicating 2D-xy output variables
@@ -1472,7 +1476,8 @@
 
 !
-!-- Day of year, UTC
-    WRITE ( io, 456 )  day_of_year_init, time_utc_init
-    
+!-- Day and time during model start
+    CALL get_date_time( 0.0_wp, date_time_str=date_time_str )
+    WRITE ( io, 456 )  TRIM( date_time_str )
+
 !
 !-- Other quantities
@@ -1858,6 +1863,5 @@
 454 FORMAT ('    TKE is not allowed to fall below ',E9.2,' (m/s)**2')
 455 FORMAT ('    initial TKE is prescribed as ',E9.2,' (m/s)**2')
-456 FORMAT (/'    Day of the year at model start :   day_init      =     ',I3 &
-            /'    UTC time at model start        :   time_utc_init = ',F7.1,' s')
+456 FORMAT (/'    Date and time at model start : ',A)
 457 FORMAT ('    RANS-mode constants: c_0 = ',F9.5/         &
             '                         c_1 = ',F9.5/         &
Index: /palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4227)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! -----------------
-!
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+!
+! 4217 2019-09-04 09:47:05Z scharf
 ! Corrected "Former revisions" section
 !
@@ -1053,12 +1056,12 @@
 !         ONLY:  c_p
 
-!     USE control_parameters,                                                    &
-!         ONLY:  rho_surface
-
-    USE date_and_time_mod,                                                     &
-        ONLY:  time_utc
+    USE control_parameters,                                                    &
+        ONLY:  time_since_reference_point
 
     USE grid_variables,                                                        &
         ONLY:  dx, dy
+
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time, seconds_per_hour
 
     USE pegrid
@@ -1085,4 +1088,5 @@
     REAL(wp) ::  indoor_wall_window_temperature   !< weighted temperature of innermost wall/window layer
     REAL(wp) ::  near_facade_temperature          !< outside air temperature 10cm away from facade
+    REAL(wp) ::  second_of_day                    !< second of the current day
     REAL(wp) ::  time_utc_hour                    !< time of day (hour UTC)
 
@@ -1091,5 +1095,6 @@
 !
 !-- Determine time of day in hours. 
-    time_utc_hour = time_utc / 3600.0_wp
+    CALL get_date_time( time_since_reference_point, second_of_day=second_of_day )
+    time_utc_hour = second_of_day / seconds_per_hour
 !
 !-- Following calculations must be done for each facade element.
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 4226)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4223 2019-09-10 09:20:47Z gronemeier
 ! Deallocate temporary string array since it may be re-used to read different 
 ! input data in other modules
@@ -177,4 +180,7 @@
         ONLY:  nesting_offl_init
 
+    USE palm_date_time_mod,                                                    &
+        ONLY:  set_reference_date_time
+
     USE pegrid
 
@@ -266,4 +272,7 @@
     
     CALL location_message( 'model initialization', 'start' )
+!
+!-- Set reference date-time
+    CALL set_reference_date_time( date_time_str=origin_date_time )
 
     IF ( debug_output )  CALL debug_message( 'allocating arrays', 'start' )
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 4226)
+++ /palm/trunk/SOURCE/modules.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Add origin_date_time
+! 
+! 4146 2019-08-07 07:47:36Z gronemeier
 ! Added rotation_angle
 ! 
@@ -471,4 +474,5 @@
     CHARACTER (LEN=8)    ::  coupling_char = ''                           !< appended to filenames in coupled or nested runs ('_O': ocean PE,
                                                                           !< '_NV': vertically nested atmosphere PE, '_N##': PE of nested domain ##
+    CHARACTER (LEN=23)   ::  origin_date_time = '2019-06-21 12:00:00 +00' !< date and time to be simulated
     CHARACTER (LEN=10)   ::  run_date = ' '                               !< date of simulation run
     CHARACTER (LEN=8)    ::  run_time = ' '                               !< time of simulation run
Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4227)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! implement new palm_date_time_mod
 ! 
 ! Former revisions:
@@ -164,7 +164,4 @@
                log_point_s
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  time_utc_init
-
     USE grid_variables
 
@@ -191,4 +188,7 @@
                pids_id
 
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time
+
     USE pegrid
 
@@ -274,4 +274,5 @@
 
     REAL(wp) ::  fac_dt              !< interpolation factor
+    REAL(wp) ::  time_utc_init       !< time in seconds-of-day of origin_date_time
     REAL(wp) ::  zi_ribulk = 0.0_wp  !< boundary-layer depth according to bulk Richardson criterion, i.e. the height where Ri_bulk exceeds the critical
                                      !< bulk Richardson number of 0.2
@@ -1800,4 +1801,7 @@
        INTEGER(iwp) ::  n !< running index for chemical species
 
+!
+!--    Get time_utc_init from origin_date_time
+       CALL get_date_time( 0.0_wp, second_of_day = time_utc_init )
 
 !--    Allocate arrays for geostrophic wind components. Arrays will 
